import{s as Tt,n as $t,o as At}from"../chunks/scheduler.f6b352c8.js";import{S as Pt,i as Ht,g as l,s as i,r as Z,A as Lt,h as o,f as n,c as a,j as wt,u as tt,x as r,k as Ct,y as Mt,a as s,v as et,d as nt,t as st,w as it}from"../chunks/index.7f38e934.js";import{H as _t}from"../chunks/Heading.333929c4.js";import{E as kt}from"../chunks/EditOnGithub.c3245a01.js";function Et(at){let p,M,H,k,d,E,u,lt="Observations are <strong>how an Agent perceives the consequences of its actions</strong>.",R,m,ot="They provide crucial information that fuels the Agent’s thought process and guides future actions.",z,f,rt="They are <strong>signals from the environment</strong>—whether it’s data from an API, error messages, or system logs—that guide the next cycle of thought.",I,h,pt="In the observation phase, the agent:",O,c,dt="<li><strong>Collects Feedback:</strong> Receives data or confirmation that its action was successful (or not).</li> <li><strong>Appends Results:</strong> Integrates the new information into its existing context, effectively updating its memory.</li> <li><strong>Adapts its Strategy:</strong> Uses this updated context to refine subsequent thoughts and actions.</li>",q,v,ut="For example, if a weather API returns the data <em>“partly cloudy, 15°C, 60% humidity”</em>, this observation is appended to the agent’s memory (at the end of the prompt).",S,g,mt="The Agent then uses it to decide whether additional information is needed or if it’s ready to provide a final answer.",j,b,ft="This <strong>iterative incorporation of feedback ensures the agent remains dynamically aligned with its goals</strong>, constantly learning and adjusting based on real-world outcomes.",F,x,ht="These observations <strong>can take many forms</strong>, from reading webpage text to monitoring a robot arm’s position. This can be seen like Tool “logs” that provide textual feedback of the Action execution.",D,y,ct="<thead><tr><th>Type of Observation</th> <th>Example</th></tr></thead> <tbody><tr><td>System Feedback</td> <td>Error messages, success notifications, status codes</td></tr> <tr><td>Data Changes</td> <td>Database updates, file system modifications, state changes</td></tr> <tr><td>Environmental Data</td> <td>Sensor readings, system metrics, resource usage</td></tr> <tr><td>Response Analysis</td> <td>API responses, query results, computation outputs</td></tr> <tr><td>Time-based Events</td> <td>Deadlines reached, scheduled tasks completed</td></tr></tbody>",U,w,B,C,vt="After performing an action, the framework follows these steps in order:",G,_,gt="<li><strong>Parse the action</strong> to identify the function(s) to call and the argument(s) to use.</li> <li><strong>Execute the action.</strong></li> <li><strong>Append the result</strong> as an <strong>Observation</strong>.</li>",N,W,J,T,bt="We’ve now learned the Agent’s Thought-Action-Observation Cycle.",K,$,xt="If some aspects still seem a bit blurry, don’t worry—we’ll revisit and deepen these concepts in future Units.",Q,A,yt="Now, it’s time to put your knowledge into practice by coding your very first Agent!",V,P,X,L,Y;return d=new _t({props:{title:"Observe: Integrating Feedback to Reflect and Adapt",local:"observe-integrating-feedback-to-reflect-and-adapt",headingTag:"h1"}}),w=new _t({props:{title:"How Are the Results Appended?",local:"how-are-the-results-appended",headingTag:"h2"}}),P=new kt({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit1/observations.mdx"}}),{c(){p=l("meta"),M=i(),H=l("p"),k=i(),Z(d.$$.fragment),E=i(),u=l("p"),u.innerHTML=lt,R=i(),m=l("p"),m.textContent=ot,z=i(),f=l("p"),f.innerHTML=rt,I=i(),h=l("p"),h.textContent=pt,O=i(),c=l("ul"),c.innerHTML=dt,q=i(),v=l("p"),v.innerHTML=ut,S=i(),g=l("p"),g.textContent=mt,j=i(),b=l("p"),b.innerHTML=ft,F=i(),x=l("p"),x.innerHTML=ht,D=i(),y=l("table"),y.innerHTML=ct,U=i(),Z(w.$$.fragment),B=i(),C=l("p"),C.textContent=vt,G=i(),_=l("ol"),_.innerHTML=gt,N=i(),W=l("hr"),J=i(),T=l("p"),T.textContent=bt,K=i(),$=l("p"),$.textContent=xt,Q=i(),A=l("p"),A.textContent=yt,V=i(),Z(P.$$.fragment),X=i(),L=l("p"),this.h()},l(t){const e=Lt("svelte-u9bgzb",document.head);p=o(e,"META",{name:!0,content:!0}),e.forEach(n),M=a(t),H=o(t,"P",{}),wt(H).forEach(n),k=a(t),tt(d.$$.fragment,t),E=a(t),u=o(t,"P",{"data-svelte-h":!0}),r(u)!=="svelte-75lxoz"&&(u.innerHTML=lt),R=a(t),m=o(t,"P",{"data-svelte-h":!0}),r(m)!=="svelte-tbzh8a"&&(m.textContent=ot),z=a(t),f=o(t,"P",{"data-svelte-h":!0}),r(f)!=="svelte-1k9ntrh"&&(f.innerHTML=rt),I=a(t),h=o(t,"P",{"data-svelte-h":!0}),r(h)!=="svelte-1c1h48j"&&(h.textContent=pt),O=a(t),c=o(t,"UL",{"data-svelte-h":!0}),r(c)!=="svelte-rywryb"&&(c.innerHTML=dt),q=a(t),v=o(t,"P",{"data-svelte-h":!0}),r(v)!=="svelte-19ozppp"&&(v.innerHTML=ut),S=a(t),g=o(t,"P",{"data-svelte-h":!0}),r(g)!=="svelte-1aqo02t"&&(g.textContent=mt),j=a(t),b=o(t,"P",{"data-svelte-h":!0}),r(b)!=="svelte-9mn0ub"&&(b.innerHTML=ft),F=a(t),x=o(t,"P",{"data-svelte-h":!0}),r(x)!=="svelte-19ewwzk"&&(x.innerHTML=ht),D=a(t),y=o(t,"TABLE",{"data-svelte-h":!0}),r(y)!=="svelte-327b0l"&&(y.innerHTML=ct),U=a(t),tt(w.$$.fragment,t),B=a(t),C=o(t,"P",{"data-svelte-h":!0}),r(C)!=="svelte-13dnszo"&&(C.textContent=vt),G=a(t),_=o(t,"OL",{"data-svelte-h":!0}),r(_)!=="svelte-1jve1w4"&&(_.innerHTML=gt),N=a(t),W=o(t,"HR",{}),J=a(t),T=o(t,"P",{"data-svelte-h":!0}),r(T)!=="svelte-qz4om0"&&(T.textContent=bt),K=a(t),$=o(t,"P",{"data-svelte-h":!0}),r($)!=="svelte-gjur3l"&&($.textContent=xt),Q=a(t),A=o(t,"P",{"data-svelte-h":!0}),r(A)!=="svelte-1an6zws"&&(A.textContent=yt),V=a(t),tt(P.$$.fragment,t),X=a(t),L=o(t,"P",{}),wt(L).forEach(n),this.h()},h(){Ct(p,"name","hf:doc:metadata"),Ct(p,"content",Rt)},m(t,e){Mt(document.head,p),s(t,M,e),s(t,H,e),s(t,k,e),et(d,t,e),s(t,E,e),s(t,u,e),s(t,R,e),s(t,m,e),s(t,z,e),s(t,f,e),s(t,I,e),s(t,h,e),s(t,O,e),s(t,c,e),s(t,q,e),s(t,v,e),s(t,S,e),s(t,g,e),s(t,j,e),s(t,b,e),s(t,F,e),s(t,x,e),s(t,D,e),s(t,y,e),s(t,U,e),et(w,t,e),s(t,B,e),s(t,C,e),s(t,G,e),s(t,_,e),s(t,N,e),s(t,W,e),s(t,J,e),s(t,T,e),s(t,K,e),s(t,$,e),s(t,Q,e),s(t,A,e),s(t,V,e),et(P,t,e),s(t,X,e),s(t,L,e),Y=!0},p:$t,i(t){Y||(nt(d.$$.fragment,t),nt(w.$$.fragment,t),nt(P.$$.fragment,t),Y=!0)},o(t){st(d.$$.fragment,t),st(w.$$.fragment,t),st(P.$$.fragment,t),Y=!1},d(t){t&&(n(M),n(H),n(k),n(E),n(u),n(R),n(m),n(z),n(f),n(I),n(h),n(O),n(c),n(q),n(v),n(S),n(g),n(j),n(b),n(F),n(x),n(D),n(y),n(U),n(B),n(C),n(G),n(_),n(N),n(W),n(J),n(T),n(K),n($),n(Q),n(A),n(V),n(X),n(L)),n(p),it(d,t),it(w,t),it(P,t)}}}const Rt='{"title":"Observe: Integrating Feedback to Reflect and Adapt","local":"observe-integrating-feedback-to-reflect-and-adapt","sections":[{"title":"How Are the Results Appended?","local":"how-are-the-results-appended","sections":[],"depth":2}],"depth":1}';function zt(at){return At(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class jt extends Pt{constructor(p){super(),Ht(this,p,zt,Et,Tt,{})}}export{jt as component};
